///////////////////////////////////////////////////////////
// CENTRDLG.CPP
///////////////////////////////////////////////////////////

#include <owl\pch.h>
#pragma hdrstop
#include <owl\button.h>
#include "centrdlg.rc"

//////////////////////////////////
// The dialog class.
//////////////////////////////////
class TDlg : public TDialog
{
public:
	TDlg(TWindow *parent, TResId resId);
protected:
	void SetupWindow();
	void CmPushButton1();
//	void EvTimer(UINT);
private:
	TButton *button1;
DECLARE_RESPONSE_TABLE(TDlg);
};

DEFINE_RESPONSE_TABLE1(TDlg, TDialog)
//	EV_WM_TIMER,
	EV_COMMAND(IDC_PUSHBUTTON1, CmPushButton1),
END_RESPONSE_TABLE;


TDlg::TDlg(TWindow *parent, TResId resId)
	: TDialog(parent, resId)
{
	button1 = new TButton(this, IDC_PUSHBUTTON1);
}


void TDlg::SetupWindow()
{
	TDialog::SetupWindow();

	TRect dialogRect = GetWindowRect();	// get dialog size
	if (Parent->Attr.Menu)
		dialogRect = dialogRect.Inflate(1, 20);
	else {
		dialogRect.right += 2;
		dialogRect.bottom += 21;
	}
	if (Parent->Attr.Style & WS_THICKFRAME)
		dialogRect = dialogRect.Inflate(3, 3);

	TPoint topLeft((GetSystemMetrics(SM_CXSCREEN) - dialogRect.Width()) / 2,
		((GetSystemMetrics(SM_CYSCREEN) - dialogRect.Height()) / 2));
	TRect newPosition(topLeft, dialogRect.Size());
	Parent->MoveWindow(newPosition);
}


void TDlg::CmPushButton1()
{
	TRect parentWindow = Parent->GetWindowRect();
	TRect dialogRect = GetWindowRect();	// get dialog size

	int leftMargin = parentWindow.left;
	int topMargin = parentWindow.top;
	int rightMargin = GetSystemMetrics(SM_CXSCREEN) - parentWindow.right;
	int bottomMargin = GetSystemMetrics(SM_CYSCREEN) - parentWindow.bottom;

	char buf[100];
	wsprintf(buf, "Parent = %dx%d\n"
								"Client = %dx%d\n\n"
								"Left Margin = %d\n"
								"Right Margin = %d\n"
								"Top Margin = %d\n"
								"Bottom Margin = %d\n",
		parentWindow.Width(), parentWindow.Height(),
		dialogRect.Width(), dialogRect.Height(),
		leftMargin, rightMargin, topMargin, bottomMargin);
	MessageBox(buf, "Message");
}

//////////////////////////////////
// The application class.
//////////////////////////////////
class TApp : public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};

///////////////////////////////////////////////////////////
// TApp::InitMainWindow()
///////////////////////////////////////////////////////////
void TApp::InitMainWindow()
{
	// Construct the dialog box.
	TDialog *dialog = new TDlg(0, TESTDLG);

	// Construct the main window with the
	// dialog box as the client window.
	TFrameWindow *wndw =
		new TFrameWindow(0, "Main Dialog with Menu",
		dialog, TRUE);

	// Assign a menu to the main window.
	wndw->AssignMenu(MENU_1);
	wndw->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
//	wndw->Attr.Style &= ~(WS_MAXIMIZEBOX);

	SetMainWindow(wndw);
	EnableCtl3d();
}

///////////////////////////////////////////////////////////
// OwlMain()
///////////////////////////////////////////////////////////
int OwlMain(int, char*[])
{
   return TApp().Run();
}


